<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

use Teknisa\GER\Controllers\TeknisaCrud;
use Teknisa\PED\Modules\Pedidos\Services\Ped05001EquipeVendedorMetaService;
use \Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\GER\Controllers\CrudController;
use Zeedhi\Framework\DataSource\ParameterBag;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;


class Ped05001EquipeVendedorMetaController extends TeknisaCrud {

    protected $dataSourceName;
    protected $parameterBagColumns;
    protected $EquipeVendedorMetaService;

    public function __construct($crudService, ParameterBag $parameterBag, $EquipeVendedorMetaService) {
        $this->EquipeVendedorMetaService = $EquipeVendedorMetaService;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function getNrSeq(DTO\Request $request, DTO\Response $response)  {
        $row  = $request->getRow();
        $nrseq = $row[0];
        $nrseq = $this->EquipeVendedorMetaService->geraNrSeq($nrseq);
        $dataSet = new DataSet ('data',$nrseq);
        $response->addDataSet($dataSet);
    }
    
    public function exportMembros(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = 'equipevendedor';
        $row  = $request->getRow();
        //SUBISTITUIR
        if ($row[0] == 'sub') {
            for($i=0;$i<count($row[1]);$i++) {
                $existing = $this->EquipeVendedorMetaService->searchMembrosEquipe($row[1][$i]["CDEQUIPE"]);   
                for($e=0;$e<count($existing);$e++) {
                    $existing[$e]['__is_new'] = false;
                    $dataSet = new DataSet($this->dataSourceName, array($existing[$e]));
                    $requestDel = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                    parent::delete($requestDel, $response);
                }
            }
            try {
                $newMembros = $this->EquipeVendedorMetaService->geraMembrosSub($row);
                foreach($newMembros as $membro) {
                    $membro['__is_new'] = true;
                    $dataSet = new DataSet($this->dataSourceName, array($membro));
                    $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                    parent::save($requestSalvar, $response);
                }
            } catch (\Exception $e) {
                if(!(count($response->getError()))) {
                    $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
                }
            }
        } 
        //ADICIONAR
        else if ($row[0] == 'add'){
            try {
                $newMembros = $this->EquipeVendedorMetaService->geraMembrosAdd($row);
                foreach($newMembros as $membro) {
                    $membro['__is_new'] = true;
                    $dataSet = new DataSet($this->dataSourceName, array($membro));
                    $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                    parent::save($requestSalvar, $response);
                }
            } catch (\Exception $e) {
                if(!(count($response->getError()))) {
                    $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
                }
            }
        }
    }
    
    public function importMembros (DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = 'equipevendedor';
        $row  = $request->getRow();
        if ($row[0] == 'sub') {
            if($row[2]) {
                $existing = $this->EquipeVendedorMetaService->searchMembrosEquipe($row[2][0]["CDEQUIPE"]);   
                for($e=0;$e<count($existing);$e++) {
                    $existing[$e]['__is_new'] = false;
                    $dataSet = new DataSet($this->dataSourceName, array($existing[$e]));
                    $requestDel = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                    parent::delete($requestDel, $response);
                }
            }
            try {
                    
                $newMembros = $this->EquipeVendedorMetaService->geraImportMembrosSub($row);
                foreach($newMembros as $membro) {
                    $membro['__is_new'] = true;
                    $dataSet = new DataSet($this->dataSourceName, array($membro));
                    $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                    parent::save($requestSalvar, $response);
                }
            } catch (\Exception $e) {
                if(!(count($response->getError()))) {
                    $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
                }
            }
        }
        else if ($row[0] == 'add') {
             try {
                $newMembros = $this->EquipeVendedorMetaService->geraImportMembrosAdd($row);
                if($row[2]) {
                    $existing = $this->EquipeVendedorMetaService->searchMembrosEquipe($row[2][0]["CDEQUIPE"]);   
                    for($e=0;$e<count($existing);$e++) {
                        $existing[$e]['__is_new'] = false;
                        $dataSet = new DataSet($this->dataSourceName, array($existing[$e]));
                        $requestDel = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                        parent::delete($requestDel, $response);
                    }   
                }
                
                foreach($newMembros as $membro) {
                    $membro['__is_new'] = true;
                    $dataSet = new DataSet($this->dataSourceName, array($membro));
                    $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                    parent::save($requestSalvar, $response);
                }
            } catch (\Exception $e) {
                if(!(count($response->getError()))) {
                    $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
                }
            }
        }
    }

}