<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

    use Teknisa\PED\Controllers\TeknisaCrud;
    use Doctrine\ORM\EntityManager;
    use Zeedhi\Framework\DataSource\ParameterBag;
    use Teknisa\Libs\Util\Libraries\PHPMailer;
    use Teknisa\PED\Modules\Pedidos\Services\Ped05700importacaoSolicitacaoComprasService;
    use Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\FilterCriteria;
    use Zeedhi\Framework\DTO\Response\Error;
    use Zeedhi\Framework\DTO\Request\Row;
    use Zeedhi\Framework\DTO;

class Ped05700importacaoSolicitacaoComprasController extends TeknisaCrud {
    protected $entityManager;
    protected $environment;
    protected $Ped05700importacaoSolicitacaoComprasService;
    
    public function __construct($crudService, $parameterBag, $entityManager,  $environment, $Ped05700importacaoSolicitacaoComprasService){
        parent::__construct($crudService, $parameterBag);
        $this->entityManager        	= $entityManager;
        $this->environment              = $environment;
        $this->parameterBag             = $parameterBag;
        $this->Ped05700importacaoSolicitacaoComprasService = $Ped05700importacaoSolicitacaoComprasService;
    }
    
    
    public function importarSolicitacoes(DTO\Request $request, DTO\Response $response) {
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();

        $cdfilial = $this->environment->getCdFilial();
        
        $cdsProdFator = array();
        $cdsErroItemSoli = array();    
        
        $parampedido = $this->selectParmped($cdfilial);
        $arrayErro = $this->validaParamped($row,$parampedido);
        
        if($arrayErro == []){
            $stParam = $parampedido['IDTABPRECO'];
            $paramImpPed = $this->selectParamImpPed($cdfilial);
        }else{
            var_dump($arrayErro);
        }
        
        
            
        forEach($rows as $row){
            
            $erro = false;
            
            
            if($arrayErro == []){
                $precoBase = $this->Ped05700importacaoSolicitacaoComprasService->buscaPrecoBase($parampedido['CDFILIAL'], $parampedido['CDCLIENTE'], $parampedido['CDVENDEDOR'], $parampedido['CDMODPGTO']);
                
                if($paramImpPed['IDIMPSCDTENTR'] == 'S'){       
                        if($row !=null){    
                            $cdfilsoli = $row['CDFILSOLI'];
                            $cdfillan = $row['CDFILLANCA'];
                            $nrsolicmp = $row['NRSOLICMP'];
                            $dtprogentr = $row['DTPROGENTR'];
                            if($row['DTPROGENTR'] == null){
                                $tdtprogentr = 'T';
                            }else{
                                $tdtprogentr = null;
                            }

                            $itemSoliRelacProdSC = $this->Ped05700importacaoSolicitacaoComprasService->buscaitemSoliRelacProdSC($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $tdtprogentr, $cdfilial);
                            if($itemSoliRelacProdSC != null){
                                forEach($itemSoliRelacProdSC as $rowItemSoli){
                                    array_push($cdsProdFator, $rowItemSoli);                                
                                }
                                $erro = true;
                            }
                            
                            if(!$erro){
                                if($stParam == 2){
                                    $ProdFatorDtEnt = $this->Ped05700importacaoSolicitacaoComprasService->buscaProdFatorDtEnt($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $tdtprogentr, $cdfilial);
                                    if($ProdFatorDtEnt != null){
                                        forEach($ProdFatorDtEnt as $rowProdFator){
                                            array_push($cdsProdFator, $rowProdFator);
                                        }
                                        $erro = true;
                                    }
                                }else{
                                    if($precoBase == null){
                                        $erro = true;   
                                    }
                                    
                                    if(!$erro){
                                        $precoBaseDtEnt = $this->Ped05700importacaoSolicitacaoComprasService->buscaPrecoBaseDtEnt($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $tdtprogentr, $cdfilial);
                                        if($precoBaseDtEnt != null){
                                            forEach($precoBaseDtEnt as $rowPrecoBase){
                                                array_push($cdsProdFator, $rowPrecoBase);
                                            }
                                            $erro = true;
                                        }
                                        $result ='PREC_N_CAD';
                                    }
                                }
                            }else{
                                $result ='SEM_PRECO';
                            }
                        }
                }else{
                    $itemSoli = $this->Ped05700importacaoSolicitacaoComprasService->buscaItemSoli($cdfilsoli, $cdfillan, $nrsolicmp, 0, 'T');
                    if($itemSoli == null){
                        array_push($cdsErroItemSoli, $row);
                    }else{
                        $itemSoliRelacProdSC = $this->Ped05700importacaoSolicitacaoComprasService->buscaitemSoliRelacProdSC($cdfilsoli, $cdfillan, $nrsolicmp, 0, 'T', $cdfilial);
                        if($itemSoliRelacProdSC != null){
                            forEach($itemSoliRelacProdSC as $rowItemSoli){
                                array_push($cdsProdFator, $rowItemSoli);                                
                            }
                            $erro = true;
                            $result ='PROD_N_RELAC';
                        }
                        
                    }
                    
                    if(!$erro){
                        $parampedidoCdFiliSoli = $this->selectParmped($cdfilsoli);
                        if($parampedidoCdFiliSoli != null){
                            if($parampedidoCdFiliSoli['CDCLIENTE'])
                                $stCliente = $parampedidoCdFiliSoli['CDCLIENTE'];
                            
                            if($parampedidoCdFiliSoli['CDVENDEDOR'])
                                $stVendedor = $parampedidoCdFiliSoli['CDVENDEDOR'];
                                
                            if($parampedidoCdFiliSoli['CDMODPGTO'])
                                $stModPagto = $parampedidoCdFiliSoli['CDMODPGTO'];
                        }
                    }
                    
                    $stResultFunc = $this->Ped05700importacaoSolicitacaoComprasService->prodFator();
                    if($stResultFunc = 'SEM_PRECO')
                        $result ='SEM_PRECO';
                    if($stResultFunc = 'PRECO_00')
                        $result ='PRECO_00';
                    
                }
                
            }else{
                $parampedidoCdFiliSoli = $this->selectParmped($cdfilsoli);
                if($parampedidoCdFiliSoli == null){
                    $stParam = 1;
                }else{
                    $stParam = $parampedidoCdFiliSoli['IDTABPRECO'];
                }
                
                $itemSoli = $this->Ped05700importacaoSolicitacaoComprasService->buscaItemSoli($cdfilsoli, $cdfillan, $nrsolicmp, 0, 'T');
                if($itemSoli == null){
                    array_push($cdsErroItemSoli, $row);
                }else{
                    $itemSoliRelacProdSC = $this->Ped05700importacaoSolicitacaoComprasService->buscaitemSoliRelacProdSC($cdfilsoli, $cdfillan, $nrsolicmp, 0, 'T', $cdfilial);
                    if($itemSoliRelacProdSC != null){
                        forEach($itemSoliRelacProdSC as $rowItemSoli){
                            array_push($cdsProdFator, $rowItemSoli);                                
                        }
                        $erro = true;
                        $result ='PROD_N_RELAC';
                    }
                    
                }
                
                if(!$erro){
                    $parampedidoCdFiliSoli = $this->selectParmped($cdfilsoli);
                    if($parampedidoCdFiliSoli != null){
                        if($parampedidoCdFiliSoli['CDCLIENTE'])
                            $stCliente = $parampedidoCdFiliSoli['CDCLIENTE'];
                        
                        if($parampedidoCdFiliSoli['CDVENDEDOR'])
                            $stVendedor = $parampedidoCdFiliSoli['CDVENDEDOR'];
                            
                        if($parampedidoCdFiliSoli['CDMODPGTO'])
                            $stModPagto = $parampedidoCdFiliSoli['CDMODPGTO'];
                    }
                }
                
                $fator = $this->Ped05700importacaoSolicitacaoComprasService->buscaFator('', 'T');
                $stResultProdFator = $this->prodFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator, $stParam, $stCliente, $stVendedor, $stModPagto, $cdsProdFator);
                
                $cdsProdFator = $stResultProdFator['cdsProdFator'];
                $stResultFunc = $stResultProdFator['stVerifPreco'];
                
                if($stResultFunc == 'SEM_PRECO')
                    $result ='SEM_PRECO';
                if($stResultFunc == 'PRECO_00')
                    $result ='PRECO_00';
                
            }
            
        }
        
        return $result;

    }
    
    public function selectParmped($cdfilial){
        $arrayErro = [];
        
        try{
            $filter= array(
                        array("columnName" => "CDFILIAL",
                            "operator" => "=",
                            "value" => $cdfilial
                        )
                     );
            
            $dadosParamped = new DTO\Response();
            $filterCriteria = new FilterCriteria('parampedido', $filter);
            $this->crudService->find($dadosParamped, $filterCriteria);
            $parampedido = $dadosParamped->getDataSets();
            
            if(count($parampedido[0]->getRows()) == 0){
                array_push($arrayErro, 'Parametrização de pedidos não encontrada');
                return $arrayErro;
            }else{
                $parampedido = $parampedido[0]->getRows()[0];
                return $parampedido;
            }
        }catch(\Exception $e){
            throw $e;
        }
        
    }
    
    public function selectParamImpPed($cdfilial){
        try{
            $filter = array(
                        array("columnName" => "CDFILIAL",
                          "operator" => "=",
                          "value" => $cdfilial
                        )
                      );
            
            $dadosparamimppedido = new DTO\Response();
            $filterCriteria = new FilterCriteria('paramimppedido', $filter);
            $this->crudService->find($dadosparamimppedido, $filterCriteria);
            
            $paramimppedido = $dadosparamimppedido->getDataSets();
            $paramimppedido = $paramimppedido[0]->getRows()[0];
            
            return $paramimppedido;
        }catch(\Exception $e){
            throw $e;
        }
        
    }
    
    public function validaParamped($row, $parampedido){
    
            $erro = false; 
            $arrayErro = [];

            //Validações da parampedido
            if ($parampedido == null){
                $stParam = 1;
            }else{
                $stParam = $parampedido['IDTABPRECO'];
            }
           
            if ($parampedido['IDOBRTPOPPED'] == 'S' && $parampedido['CDTIPOOPER'] == null){
                $erro == true;
                array_push($arrayErro, 'Erro IDOBRTPOPPED');
            }
            
            if ($parampedido['CDCLIENTE'] == null){
                $erro = true;
                array_push($arrayErro, 'Erro CDCLIENTE');
            }
            
            if ($parampedido['CDVENDEDOR'] == null){
                $erro = true;
                array_push($arrayErro, 'Erro CDVENDEDOR');
            }
            
            if ($parampedido['CDMODPGTO'] == null){
                $erro = true;
                array_push($arrayErro, 'Erro CDMODPGTO');
            }   
            
            return $arrayErro;
    }
    
    public function prodFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator, $stParam, $stCliente, $stVendedor, $stModPagto, $cdsProdFator){
        $stResult;
        $stVerifPreco;
        
        if($stParam = 2){
            $prodFator = $this->Ped05700importacaoSolicitacaoComprasService->buscaProdFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator);
            if($prodFator != null){
                forEach($prodFator as $rowProdFator){
                    array_push($cdsProdFator, $rowProdFator);                                
                }
                //result := 'NAO_OK'
            }else{
                //result := 'OK'
            }
        }else{
            $stResult = $this->Ped05700importacaoSolicitacaoComprasService->buscaPrecoBase($cdfilial, $stCliente, $stVendedor, $stModPagto);
            if($stResult == null){
                $stResult = 'SEM_PRECO';
            }
            
            if($stResult == 'SEM_PRECO'){
                $stVerifPreco = 'OK';
                $selectPrecoBase = $this->Ped05700importacaoSolicitacaoComprasService->selectPrecoBase($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult);
                if($selectPrecoBase == null){
                    $stVerifPreco = 'OK';
                }else{
                    forEach($selectPrecoBase as $rowPrecoBase){
                        array_push($cdsProdFator, $rowPrecoBase);                                
                    }
                    $stVerifPreco = 'NAO_OK';
                }
                
                if($stVerifPreco == 'OK'){
                    $selectDataEndPed = $this->Ped05700importacaoSolicitacaoComprasService->selectDataEndPed($cdfilsoli, $cdfillan, $nrsolicmp);
                
                    $selectValidaPreco = $this->Ped05700importacaoSolicitacaoComprasService->selectValidaPreco($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $selectDataEndPed['DTENTREGA']);
                
                    if($selectValidaPreco != null){
                        $stVerifPreco = 'NAO_OK';
                    }else{
                        $selectVerificaPrecoZerado = $this->Ped05700importacaoSolicitacaoComprasService->selectVerificaPrecoZerado($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $selectDataEndPed['DTENTREGA']);
                        if($selectVerificaPrecoZerado != null){
                            $stVerifPreco = 'PRECO_00';
                             
                            forEach($selectVerificaPrecoZerado as $rowVerificaPrecoZerado){
                                array_push($cdsProdFator, $rowVerificaPrecoZerado);                                
                            }
                        }
                        
                    }
                }
                
                $dados = array(
                    'cdsProdFator' => $cdsProdFator,
                    'stVerifPreco' => $stVerifPreco
                );
                
                return $dados;
            }
        }
    }
    
    // public function Importar($cdfilial, cdsSolicita.Data, Operador, stCdFator, stCdFili, stTodos, depDeSoli.Date, depAteSoli.Date, stProdIni, stProdFin, stTProduto, cdsGrupoCDGRUPPROD.AsString, stSubGrupo, stTSubGrupo){
        
    // }
};