<?php
namespace Teknisa\PED\Modules\Pedidos\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\PED\Modules\Pedidos\Factories\Ped05700importacaoSolicitacaoComprasFactory;
use Teknisa\Libs\Util\DateUtil;
use Teknisa\Libs\Util\NewCode;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\Manager\SQL\ManagerImpl;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class Ped05700importacaoSolicitacaoComprasService{
    protected $entityManager;
	protected $environment;
    protected $dataSourceManager;
	protected $Ped05700importacaoSolicitacaoComprasFactory;

	public function __construct(EntityManager $entityManager, Environment $environment, ManagerImpl $dataSourceManager, $Ped05700importacaoSolicitacaoComprasFactory){
		$this->entityManager        	= $entityManager;
		$this->environment				= $environment;
        $this->dataSourceManager		= $dataSourceManager;
		$this->Ped05700importacaoSolicitacaoComprasFactory = $Ped05700importacaoSolicitacaoComprasFactory;
        
	}
    
    
    public function buscaPrecoBase ($cdfilial, $cdcliente, $cdvendedor, $cdmodpgto){
        $precoBase = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaPrecoBase($cdfilial, $cdcliente, $cdvendedor, $cdmodpgto);
        
        return $precoBase;
    }
    
    public function buscaitemSoliRelacProdSC($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $tdtprogentr, $cdfilial){
        $itemSoliRelacProdSC = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaitemSoliRelacProdSC($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $tdtprogentr, $cdfilial);
    
        return $itemSoliRelacProdSC;
    }

    public function buscaProdFatorDtEnt($cdfilial,$nrsolicmp,$tdtprogentr,$cdfillan,$dtprogentr,$cdfilsoli){
        $prodFatorDtEnt = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaProdFatorDtEnt($cdfilial,$nrsolicmp,$tdtprogentr,$cdfillan,$dtprogentr,$cdfilsoli);
        
        return $prodFatorDtEnt;
    }
    
    public function buscaPrecoBaseDtEnt($cdfilial, $nrsolicmp, $tdtprogentr, $cdfillan, $dtprogentr, $cdfilsoli){
        $precoBaseDtEnt = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaPrecoBaseDtEnt($cdfilial, $nrsolicmp, $tdtprogentr, $cdfillan, $dtprogentr, $cdfilsoli);
        
        return $precoBaseDtEnt;
    }
    
    public function buscaItemSoli(){
        $itemSoli = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaItemSoli($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $tdtprogentr);
        
        return $itemSoli;
    }
    
    public function buscaProdFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator){
        $itemSoli = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaProdFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator);
        
        return $prodFator;
    }
    
    public function buscaFator($sgfatpreco, $tsgfatpreco){
        $fator = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaFator($sgfatpreco, $tsgfatpreco);
        
        return $fator;
    }
    
    public function selectPrecoBase($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult){
        $selectPrecoBase = $this->Ped05700importacaoSolicitacaoComprasFactory->selectPrecoBase($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult);
        
        return $selectPrecoBase;
    }
    
    public function selectDataEndPed($cdfilsoli, $cdfillan, $nrsolicmp){
        $selectDataEndPed = $this->Ped05700importacaoSolicitacaoComprasFactory->selectDataEndPed($cdfilsoli, $cdfillan, $nrsolicmp);
        
        return $selectDataEndPed;
    }
    
    public function selectValidaPreco($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $dtentrega){
        $selectValidaPreco = $this->Ped05700importacaoSolicitacaoComprasFactory->selectValidaPreco($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $dtentrega);
        
        return $selectValidaPreco;
    }
    
    public function selectVerificaPrecoZerado($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $dtentrega){
        $selectVerificaPrecoZerado = $this->Ped05700importacaoSolicitacaoComprasFactory->selectVerificaPrecoZerado($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $dtentrega);
        
        return $selectVerificaPrecoZerado;
    }
};